// ===========================================================================
// MainFrm.cpp
// main window
//
//                                                                    kanegon
// ===========================================================================

#include "stdafx.h"
#include <stdio.h>
#include <new>
#include "jresviewer.h"
#include "common.h"
#include "Option.h"
#include "OptionDlg.h"
#include "AboutDlg.h"
#include "Buffer.h"
#include "strrstr.h"
#include "MainFrm.h"

using namespace std;


//////////////////////////////////////////////////////////////////////////////

LRESULT CExExEdit::OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
	m_pParent->SendMessage(WM_UPDATECARETPOSITION, 0, 0);
	bHandled = FALSE;
	return 0;
}

LRESULT CExExEdit::OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
	TCHAR chCharCode = (TCHAR)wParam;
	if (chCharCode == VK_ESCAPE) {
		if (KfxGetProfile()->GetExitByESC() &&
			KfxGetMainWnd()->GetReadOnly()) {
			m_pParent->PostMessage(WM_CLOSE, 0, 0);
			bHandled = TRUE;
			return 0;
		}
	}
	m_pParent->SendMessage(WM_UPDATECARETPOSITION, 0, 0);
	bHandled = FALSE;
	return 0;
}

LRESULT CExExEdit::OnKeyup(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
	m_pParent->SendMessage(WM_UPDATECARETPOSITION, 0, 0);
	bHandled = FALSE;
	return 0;
}

//////////////////////////////////////////////////////////////////////////////

static const TCHAR szDefaultExtension[] = _T(".properties");

CMainFrame* g_pMainFrame = NULL;
HWND g_hwndFindReplaceDlg;


//////////////////////////////////////////////////////////////////////////////
// CMainFrame

//////////////////////////////////////////////////////////////////////////////
// \zEj

// RXgN^
CMainFrame::CMainFrame()
{
	m_szFileName[0] = '\0';
	m_bEnableFileName = FALSE;
	m_bReadOnly = FALSE;
	g_hwndFindReplaceDlg = NULL;
	m_bEnableReplaceDlg = FALSE;
	m_bLFonly = FALSE;
}

// fXgN^
CMainFrame::~CMainFrame()
{
}

// EBhE쐬
HWND CMainFrame::ExCreate()
{
	HMENU hMenu = ::LoadMenu(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_JRESVIEWER));
	if (hMenu == NULL) {
		return NULL;
	}
	HWND hWnd = Create(NULL, CWindow::rcDefault, NULL,
			WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_CLIPCHILDREN, 0, (UINT)hMenu);
	if (hWnd == NULL) {
		return NULL;
	}
	HICON hIcon = ::LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_JRESVIEWER));
	if (hIcon == NULL) {
		return NULL;
	}
	UpdateCaption();
	SetIcon(hIcon, TRUE);

	return hWnd;
}


//////////////////////////////////////////////////////////////////////////////
// message map

// EBhE
LRESULT CMainFrame::OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	RECT rc = {0, 0, 0, 0};
	m_statusbar.Create(m_hWnd, rc, NULL,
			WS_CHILD | WS_VISIBLE | CCS_BOTTOM | SBARS_SIZEGRIP,
			0,
			IDW_STATUSBAR, NULL);
	if (m_statusbar.m_hWnd == NULL) {
		return -1;
	}
	static int s_anStatusColumns[] = {-1};
	m_statusbar.SetParts(1, s_anStatusColumns);
	m_statusbar.SetText(0, "", SBT_NOBORDERS);

	m_edit.Create(m_hWnd, rc, NULL,
			WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL|
			ES_LEFT | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_MULTILINE | ES_WANTRETURN | ES_NOHIDESEL,
			WS_EX_CLIENTEDGE,
			IDW_EDIT, NULL);

	if (m_edit.m_hWnd == NULL) {
		return -1;
	}
	if (IsWinNT()) {
		m_edit.SendMessage(EM_LIMITTEXT, 0x7FFFFFFE, 0);
	}
	m_edit2.SubclassWindow(m_edit.m_hWnd);
	m_edit2.SetParent(this);

	RecalcLayout();
	SetReadOnly(FALSE);

	ZeroMemory(m_szFindText, sizeof(m_szFindText));
	ZeroMemory(m_szReplaceText, sizeof(m_szReplaceText));
	ZeroMemory(&m_FindReplaceData, sizeof(m_FindReplaceData));
	m_FindReplaceData.lStructSize = sizeof(m_FindReplaceData);
	m_FindReplaceData.hwndOwner = m_hWnd;
	m_FindReplaceData.hInstance = _Module.GetModuleInstance();
	m_FindReplaceData.Flags = FR_DOWN | FR_HIDEWHOLEWORD;
	m_FindReplaceData.lpstrFindWhat = m_szFindText;
	m_FindReplaceData.lpstrReplaceWith = m_szReplaceText;
	m_FindReplaceData.wFindWhatLen = 80;
	m_FindReplaceData.wReplaceWithLen = 80;
	m_FindReplaceData.lCustData = NULL;
	m_FindReplaceData.lpfnHook = NULL;
	m_FindReplaceData.lpTemplateName = NULL;

	g_pMainFrame = this;

	return 0;
}

// tH[JX擾ʒm
LRESULT CMainFrame::OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if (m_edit.IsWindowEnabled())
		m_edit.SetFocus();
	return 0;
}

// TCYύXʒm
LRESULT CMainFrame::OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_statusbar.SendMessage(WM_SIZE, wParam, lParam);
	RecalcLayout();
	return 0;
}

// j[ڑIʒm
LRESULT CMainFrame::OnMenuSelect(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	/* z̐Ȏw@Ȃ *
	 * vfǂF(?)        */
	UINT anDummy[] = {0, 0};
	MenuHelp(WM_MENUSELECT, wParam, lParam,
			(HMENU)lParam, _Module.GetResourceInstance(), m_statusbar, anDummy);

	return 0;
}

// j[Jꂽʒm
LRESULT CMainFrame::OnInitMenu(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	HMENU hMenu = (HMENU)wParam; 

	DWORD dwSel = m_edit.GetSel();
	BOOL bSelText = (HIWORD(dwSel) != LOWORD(dwSel));
	BOOL bCanPaste = IsClipboardData();
	BOOL bCanUndo = m_edit.CanUndo();

	EnableMenuItem(hMenu, ID_FILE_SAVE, (! m_bReadOnly) ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hMenu, ID_EDIT_CLEAR, (bSelText && ! m_bReadOnly) ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hMenu, ID_EDIT_COPY, bSelText ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hMenu, ID_EDIT_CUT, (bSelText && ! m_bReadOnly) ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hMenu, ID_EDIT_PASTE, (bCanPaste && ! m_bReadOnly) ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hMenu, ID_EDIT_UNDO, (bCanUndo && ! m_bReadOnly) ? MF_ENABLED : MF_GRAYED);

	BOOL bFindReplaceDlgShowed = ::IsWindow(g_hwndFindReplaceDlg);
	EnableMenuItem(hMenu, ID_EDIT_FIND, bFindReplaceDlgShowed ? MF_GRAYED: MF_ENABLED);
	EnableMenuItem(hMenu, ID_EDIT_REPLACE, (m_bReadOnly || bFindReplaceDlgShowed) ? MF_GRAYED: MF_ENABLED);

	return 0;
}

// ėpʒm
// Xc[`bvpŌݖgp
LRESULT CMainFrame::OnNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	UINT nCode = ((LPNMHDR)lParam)->code;

	bHandled = TRUE;

//	switch (nCode) {
//	}

	bHandled = FALSE;
	return 1;
}

// EBgEN[Y
LRESULT CMainFrame::OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if (SaveFileWithAsk()) {
		DestroyWindow();
	}
	return 0;
}

// EBhEj
LRESULT CMainFrame::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	PostQuitMessage(0);
	g_pMainFrame = NULL;
	return 0;
}

// OIt܂ OS ̏I
LRESULT CMainFrame::OnQueryEndSession(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if (! SaveFileWithAsk()) {
		return FALSE;
	}
	return TRUE;
}

// wi̓hԂ
LRESULT CMainFrame::OnEraseBkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 0;
}

// t@C̃hbvʒm
LRESULT CMainFrame::OnDropFiles(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	HDROP hDropInfo = (HDROP)wParam;

	UINT nFiles = ::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);

	if (nFiles != 1) {
		::DragFinish(hDropInfo);
		return 0;
	}

	TCHAR szPath[_MAX_PATH];
	::DragQueryFile(hDropInfo, 0, szPath, _MAX_PATH);
	::DragFinish(hDropInfo);

	if (m_bEnableFileName) {
		TCHAR szShortPath1[_MAX_PATH];
		TCHAR szShortPath2[_MAX_PATH];
		DWORD dwResult1, dwResult2;

		dwResult1 = ::GetShortPathName(m_szFileName, szShortPath1, _MAX_PATH);
		dwResult2 = ::GetShortPathName(szPath, szShortPath2, _MAX_PATH);
		if (dwResult1 != 0 && dwResult2 != 0 &&
			lstrcmpi(szShortPath1, szShortPath2) == 0) {
			return 0;
		}
	}

	if (SaveFileWithAsk()) {
		OpenExistFileDirect(szPath);
	}

	return 0;
}

// Np^Ŏw肳ꂽt@CJ
LRESULT CMainFrame::OnOpenFileOnStart(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	OpenExistFileDirect((LPCTSTR)lParam);
	return 0;
}

LRESULT CMainFrame::OnFindMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if (m_FindReplaceData.Flags & FR_FINDNEXT) {
		if (FindText()) {
			SendMessage(g_hwndFindReplaceDlg, WM_CLOSE, 0, 0);
			g_hwndFindReplaceDlg = NULL;
		} else {
			TCHAR szFmt[256];
			TCHAR szMsg[256];
			// "\"%s\" ܂B"
			::ExLoadString(IDS_FIND_NOT_FOUND, szFmt, sizeof(szFmt));
			wsprintf(szMsg, szFmt, m_FindReplaceData.lpstrFindWhat);
			FindDlgMessageBox(szMsg, MB_OK | MB_ICONINFORMATION);
			::SetFocus(g_hwndFindReplaceDlg);
		}
	} else if (m_FindReplaceData.Flags & FR_REPLACE) {
		if (! ReplaceText()) {
			TCHAR szFmt[256];
			TCHAR szMsg[256];
			// "\"%s\" ܂B"
			::ExLoadString(IDS_FIND_NOT_FOUND, szFmt, sizeof(szFmt));
			wsprintf(szMsg, szFmt, m_FindReplaceData.lpstrFindWhat);
			FindDlgMessageBox(szMsg, MB_OK | MB_ICONINFORMATION);
			::SetFocus(g_hwndFindReplaceDlg);
		}
	} else if (m_FindReplaceData.Flags & FR_REPLACEALL) {
		int nReplaceCount = 0;
		ReplaceTextAll(&nReplaceCount);
		if (nReplaceCount == 0) {
			TCHAR szFmt[256];
			TCHAR szMsg[256];
			// "\"%s\" ܂B"
			::ExLoadString(IDS_FIND_NOT_FOUND, szFmt, sizeof(szFmt));
			wsprintf(szMsg, szFmt, m_FindReplaceData.lpstrFindWhat);
			MessageBox(szMsg, MB_OK | MB_ICONINFORMATION);
		} else {
			TCHAR szFmt[256];
			TCHAR szMsg[256];
			// "%d ̕u܂B"
			::ExLoadString(IDS_REPLACE_RESULT, szFmt, sizeof(szFmt));
			wsprintf(szMsg, szFmt, nReplaceCount);
			MessageBox(szMsg, MB_OK | MB_ICONINFORMATION);
		}
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////

// VK쐬
LRESULT CMainFrame::OnFileNew(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (SaveFileWithAsk()) {
		CreateNewFile();
	}
	return 0;
}

// t@CJ
LRESULT CMainFrame::OnFileOpen(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (SaveFileWithAsk()) {
		OpenExistFile();
	}
	return 0;
}

// ㏑ۑ
LRESULT CMainFrame::OnFileSave(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (m_bReadOnly) {
		return 0;
	}
	SaveFile();
	return 0;
}

// Otĕۑ
LRESULT CMainFrame::OnFileSaveAs(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	SaveFileAs();
	return 0;
}

//
LRESULT CMainFrame::OnFileImport(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (SaveFileWithAsk()) {
		OpenExistFile(TRUE);
	}
	return 0;
}

//
LRESULT CMainFrame::OnFileExport(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	SaveFileAs(TRUE);
	return 0;
}

// ҏW - ɖ߂
LRESULT CMainFrame::OnEditUndo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_edit.Undo();
	return 0;
}

// ҏW - ؎
LRESULT CMainFrame::OnEditCut(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_edit.Cut();
	return 0;
}

// ҏW - Rs[
LRESULT CMainFrame::OnEditCopy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_edit.Copy();
	return 0;
}

// ҏW - \t
LRESULT CMainFrame::OnEditPaste(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_edit.Paste();
	return 0;
}

// ҏW - 폜
LRESULT CMainFrame::OnEditClear(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_edit.Clear();
	return 0;
}

LRESULT CMainFrame::OnEditSelectAll(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_edit.SetSel(0, -1);
	return 0;
}

// ҏW - 
LRESULT CMainFrame::OnEditFind(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (::IsWindow(g_hwndFindReplaceDlg)) {
		return 0;
	}
	m_bEnableReplaceDlg = FALSE;
	g_hwndFindReplaceDlg = ::FindText(&m_FindReplaceData);
	return 0;
}

// ҏW - ㌟
LRESULT CMainFrame::OnEditFindPrev(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_FindReplaceData.Flags &= ~FR_DOWN;
	if (m_FindReplaceData.lpstrFindWhat[0] == '\0') {
		g_hwndFindReplaceDlg = ::FindText(&m_FindReplaceData);
		return 0;
	}
	if (! FindText()) {
		TCHAR szFmt[256];
		TCHAR szMsg[256];
		// "\"%s\" ܂B"
		::ExLoadString(IDS_FIND_NOT_FOUND, szFmt, sizeof(szFmt));
		wsprintf(szMsg, szFmt, m_FindReplaceData.lpstrFindWhat);
		MessageBox(szMsg, MB_OK | MB_ICONINFORMATION);
	}
	return 0;
}

// ҏW - 
LRESULT CMainFrame::OnEditFindNext(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_FindReplaceData.Flags |= FR_DOWN;
	if (m_FindReplaceData.lpstrFindWhat[0] == '\0') {
		g_hwndFindReplaceDlg = ::FindText(&m_FindReplaceData);
		return 0;
	}
	if (! FindText()) {
		TCHAR szFmt[256];
		TCHAR szMsg[256];
		// "\"%s\" ܂B"
		::ExLoadString(IDS_FIND_NOT_FOUND, szFmt, sizeof(szFmt));
		wsprintf(szMsg, szFmt, m_FindReplaceData.lpstrFindWhat);
		MessageBox(szMsg, MB_OK | MB_ICONINFORMATION);
	}
	return 0;
}

// ҏW - u
LRESULT CMainFrame::OnEditReplace(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (::IsWindow(g_hwndFindReplaceDlg)) {
		return 0;
	}
	m_FindReplaceData.Flags |= FR_DOWN;
	m_bEnableReplaceDlg = TRUE;
	g_hwndFindReplaceDlg = ::ReplaceText(&m_FindReplaceData);
	return 0;
}

// ҏW - ҏW֎~
LRESULT CMainFrame::OnEditReadOnly(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	SetReadOnly(! m_bReadOnly);
	return 0;
}

LRESULT CMainFrame::OnToolOption(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	COptionDlg dlg;
	dlg.DoModal();
	return 0;
}

// AvP[V̏I
LRESULT CMainFrame::OnAppExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	PostMessage(WM_CLOSE, 0, 0);
	return 0;
}

// o[W_CAO\
LRESULT CMainFrame::OnAppAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	CAboutDlg dlg;
	dlg.DoModal();

	return 0;
}

// Edit Control ύXʒm
LRESULT CMainFrame::OnChangeEdit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	m_edit.SetModify(TRUE);
	UpdateCaption();

	return 0;
}

LRESULT CMainFrame::OnUpdateCaretPosition(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	UpdateCaretPosition();
	bHandled = FALSE;
	return 0;
}

LRESULT CMainFrame::OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	UpdateCaretPosition();
	bHandled = FALSE;
	return 0;
}

LRESULT CMainFrame::OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	UpdateCaretPosition();
	bHandled = FALSE;
	return 0;
}

LRESULT CMainFrame::OnKeyup(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
UpdateCaretPosition();
	bHandled = FALSE;
	return 0;
}

// test
void CMainFrame::UpdateCaretPosition()
{
	int nStartChar, nEndChar;
	m_edit.GetSel(nStartChar, nEndChar);
	int nLine = (int)m_edit.SendMessage(EM_LINEFROMCHAR,  (WPARAM)-1, 0);
	int nLineChars = m_edit.SendMessage(EM_LINEINDEX, nLine, 0);
	int nColumn = nStartChar - nLineChars;
	TCHAR sz[80];
	wsprintf(sz, "%d:%d", nLine + 1, nColumn + 1);
	m_statusbar.SetText(0, sz);
}


//////////////////////////////////////////////////////////////////////////////
// \bh

// VK쐬
void CMainFrame::CreateNewFile()
{
	m_edit.SetWindowText("");

	SetFileName(NULL);
	SetLFonly(FALSE);
	m_edit.SetModify(FALSE);
	m_edit.EmptyUndoBuffer();

	UpdateCaption();

	SetReadOnly(FALSE);

	return;
}

// t@CJ
BOOL CMainFrame::OpenExistFile(BOOL bNative/*= FALSE*/)
{
	TCHAR szFilter[256];
//	if (bNative) {
//		::ExLoadString(IDS_FILEEXT_FILTER_ALL, szFilter, sizeof(szFilter));
//	} else {
		::ExLoadString(IDS_FILEEXT_FILTER, szFilter, sizeof(szFilter));
//	}

	TCHAR szPath[_MAX_PATH];
	if (! ExGetOpenFileName(szPath, sizeof(szPath), &szDefaultExtension[1],
			OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
			szFilter,
			m_hWnd, NULL, NULL)) {
		return FALSE;
	}

	return OpenExistFileDirect(szPath, bNative);
}

// t@CJ
BOOL CMainFrame::OpenExistFileDirect(LPCTSTR pszPath, BOOL bNative/*= FALSE*/)
{
	if (! IsFile(pszPath)) {
		// t@C̓ǂݍ݂Ɏs܂B
		MessageBox(IDS_FAIL_READFILE);
		return FALSE;
	}
	TCHAR szResourcePath[_MAX_PATH] = _T("");

	lstrcpy(szResourcePath, pszPath);

	LPCTSTR pszOpenPath;
	pszOpenPath = szResourcePath;

	LPBYTE pBuffer = NULL;
	DWORD dwBufferSize = 0;
	if (! ExReadFile(pszOpenPath, &pBuffer, &dwBufferSize)) {
		// t@C̓ǂݍ݂Ɏs܂B
		MessageBox(IDS_FAIL_READFILE);
		return FALSE;
	}

	if (! bNative) {
		// Unicode GXP[v̉
		if (KfxGetProfile()->GetUseNative2Ascii()) {
			TCHAR szErrMsg[1024] = "";
			if (! UnicodeUnescapeByNative2Ascii((LPTSTR*)&pBuffer, (int*)&dwBufferSize, szErrMsg, sizeof(szErrMsg))) {
				MessageBox(szErrMsg);
				return FALSE;
			}
		} else {
			UnicodeUnescape((LPTSTR*)&pBuffer, (int*)&dwBufferSize);
		}
	}

	BOOL bLFonly = FALSE;
	RegularizeEnter(&pBuffer, (int*)&dwBufferSize, &bLFonly);

	m_edit.SetWindowText((LPCTSTR)pBuffer);

	m_edit.SetSel(0, 0);
	if (bNative) {
		SetFileName(NULL);
		SetLFonly(FALSE);
	} else {
		SetFileName(szResourcePath);
		SetLFonly(bLFonly);
	}

	delete[] pBuffer;

	if (bNative) {
		m_edit.SetModify(TRUE);
	} else {
		m_edit.SetModify(FALSE);
	}
	m_edit.EmptyUndoBuffer();
	UpdateCaption();

	if (bNative) {
		SetReadOnly(FALSE);
	} else {
		SetReadOnly(KfxGetProfile()->GetReadOnlyOpen());
	}

	return TRUE;
}

// ㏑ۑ
BOOL CMainFrame::SaveFile()
{
	if (! m_bEnableFileName) {
		return SaveFileAs();
	}

	return SaveFileDirect(GetFileName(), TRUE);
}

// Otĕۑ
BOOL CMainFrame::SaveFileAs(BOOL bNative/*= FALSE*/)
{
	static TCHAR szFilter[256];
	if (szFilter[0] == '\0') {
		::ExLoadString(IDS_FILEEXT_FILTER, szFilter, sizeof(szFilter));
	}
	TCHAR szPath[_MAX_PATH];
	if (! ExGetSaveFileName(szPath, sizeof(szPath), &szDefaultExtension[1],
			OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
			szFilter,
			m_hWnd, NULL, NULL)) {
		return FALSE;
	}

	BOOL bResult = SaveFileDirect(szPath, TRUE, bNative);

	if (bResult && ! bNative) {
		SetFileName(szPath);
		UpdateCaption();
	}

	return bResult;
}

// wt@Cɕۑ
BOOL CMainFrame::SaveFileDirect(LPCTSTR pszPath, BOOL bForce/*=TRUE*/, BOOL bNative/*=FALSE*/)
{
	DWORD dwBufferSize = m_edit.GetWindowTextLength();
	LPSTR pBuffer = new TCHAR[dwBufferSize + 1];
	m_edit.GetWindowText((LPTSTR)pBuffer, dwBufferSize + 1);
	pBuffer[dwBufferSize] = '\0';

	if (! bForce) {
		// t@C̑݊mFAсAt@C݂ꍇ̏㏑mF
	}

	if (! bNative) {
		// Unicode GXP[v
		if (KfxGetProfile()->GetUseNative2Ascii()) {
			TCHAR szErrMsg[1024] = "";
			if (! UnicodeEscapeByNative2Ascii(&pBuffer, (int*)&dwBufferSize, szErrMsg, sizeof(szErrMsg))) {
				MessageBox(szErrMsg);
				return FALSE;
			}
		} else {
			UnicodeEscape(&pBuffer, (int*)&dwBufferSize);
		}
		if (GetLFonly()) {
			MakeLFEnter((LPBYTE*)&pBuffer, (int*)&dwBufferSize);
		}
	}

	if (! ExWriteFile(pszPath, (LPBYTE)pBuffer, dwBufferSize)) {
		// t@C݂̏Ɏs܂B
		MessageBox(IDS_FAIL_WRITEFILE);
		return FALSE;
	}

	if (! bNative) {
		m_edit.SetModify(FALSE);
		m_edit.EmptyUndoBuffer();
		UpdateCaption();
	}

	return TRUE;
}

// mFtۑ
BOOL CMainFrame::SaveFileWithAsk()
{
	// ύXtOȂۑmFѕۑ
	if (m_edit.GetModify()) {
		if (! m_bEnableFileName &&
			m_edit.GetWindowTextLength() == 0) {
			return TRUE;
		}
		TCHAR szFmt[512];
		::ExLoadString(IDS_ASK_SAVE_DOCUMENT, szFmt, sizeof(szFmt));
		TCHAR szMsg[512];
		_stprintf(szMsg, szFmt, GetFileName());
		int nResult = MessageBox(szMsg, MB_YESNOCANCEL);
		if (nResult == IDCANCEL)
			return FALSE;
		if (nResult == IDYES) {
			return SaveFile();
		}
	}
	return TRUE;
}

// ҏWt@C̐ݒ
void CMainFrame::SetFileName(LPCTSTR pszFileName)
{
	if (pszFileName == NULL) {
		m_bEnableFileName = FALSE;
		m_szFileName[0] = '\0';
	} else {
		m_bEnableFileName = TRUE;
		strcpy(m_szFileName, pszFileName);
	}
}

// ҏWt@C̎擾
LPCTSTR CMainFrame::GetFileName()
{
	static TCHAR szEmptyPath[128];
	if (szEmptyPath[0] == '\0') {
		::ExLoadString(IDS_CAPTION_EMPTY_PATHNAME, szEmptyPath, sizeof(szEmptyPath));
	}
	if (m_bEnableFileName)
		return m_szFileName;
	else
		return szEmptyPath;
}

// ҏWt@C̐ݒ
void CMainFrame::SetLFonly(BOOL bLFonly)
{
	m_bLFonly = bLFonly;
}

// ҏWt@C̐ݒ
BOOL CMainFrame::GetLFonly()
{
	return m_bLFonly;
}

// EBhECAEg
void CMainFrame::RecalcLayout()
{
	RECT rc;
	RECT rcStatusbar;
	POINT posStatusbar;

	GetClientRect(&rc);
	m_statusbar.GetWindowRect(&rcStatusbar);
	posStatusbar.x = rcStatusbar.right;
	posStatusbar.y = rcStatusbar.top;
	ScreenToClient(&posStatusbar);

	m_edit.MoveWindow(rc.left, 0, rc.right, posStatusbar.y, TRUE);
}

// LvVXV
void CMainFrame::UpdateCaption()
{
	static TCHAR szUpdateText[128];
	if (szUpdateText[0] == '\0') {
		::ExLoadString(IDS_CAPTION_UPDATE_SIGN, szUpdateText, sizeof(szUpdateText));
	}
	TCHAR szCaption[1024];
	lstrcpy(szCaption, GetFileName());
	if (m_edit.GetModify())
		lstrcat(szCaption, szUpdateText);
	lstrcat(szCaption, _T(" - "));
	lstrcat(szCaption, KfxGetAppTitle());
	SetWindowText(szCaption);
}

// Nbv{[h̃eLXgf[^`FbN
BOOL CMainFrame::IsClipboardData()
{
	BOOL bFound = FALSE;
	if (! OpenClipboard())
		return FALSE;
	UINT uFormat = 0;
	while (uFormat = EnumClipboardFormats(uFormat)) {
		if(uFormat == CF_TEXT) {
			bFound =TRUE;
			break;
		}
	}
	CloseClipboard();

	return bFound;
}

// ҏW֎~ݒ
void CMainFrame::SetReadOnly(BOOL bEnable)
{
	m_bReadOnly = bEnable;
	m_edit.SendMessage(EM_SETREADONLY, m_bReadOnly, 0);

	HMENU hMainMenu = GetMenu();
	HMENU hSubMenu = GetSubMenu(hMainMenu, 1);
	if (m_bReadOnly) {
		if (::IsWindow(g_hwndFindReplaceDlg)) {
			SendMessage(g_hwndFindReplaceDlg, WM_CLOSE, 0, 0);
			g_hwndFindReplaceDlg = NULL;
		}
	}

	CheckMenuItem(hSubMenu, ID_EDIT_READONLY, MF_BYCOMMAND | (m_bReadOnly ? MF_CHECKED : MF_UNCHECKED));
}

BOOL CMainFrame::GetReadOnly()
{
	return m_bReadOnly;
}

// 
BOOL CMainFrame::FindText()
{
	// for safety
	if (m_FindReplaceData.lpstrFindWhat == NULL || m_FindReplaceData.lpstrFindWhat[0] == '\0') {
		return FALSE;
	}
	int nStartChar, nEndChar;
	m_edit.GetSel(nStartChar, nEndChar);
	// ̂тɑSeLXg擾̂͌AvP
	DWORD dwBufferSize = m_edit.GetWindowTextLength();
	LPSTR pBuffer = new TCHAR[dwBufferSize + 1];
	m_edit.GetWindowText((LPTSTR)pBuffer, dwBufferSize + 1);
	pBuffer[dwBufferSize] = '\0';
	LPCTSTR pszFindStr;
	if (m_FindReplaceData.Flags & FR_DOWN) {
		if (m_FindReplaceData.Flags & FR_MATCHCASE) {
			pszFindStr = StrStr(pBuffer + nEndChar, m_FindReplaceData.lpstrFindWhat);
		} else {
			pszFindStr = StrStrI(pBuffer + nEndChar, m_FindReplaceData.lpstrFindWhat);
		}
	} else {
		if (m_FindReplaceData.Flags & FR_MATCHCASE) {
			pszFindStr = StrRStr(pBuffer, pBuffer + nStartChar, m_FindReplaceData.lpstrFindWhat);
		} else {
			pszFindStr = StrRStrI(pBuffer, pBuffer + nStartChar, m_FindReplaceData.lpstrFindWhat);
		}
	}
	BOOL bFound = FALSE;
	if (pszFindStr != NULL) {
		m_edit.SetSel(pszFindStr - pBuffer, pszFindStr - pBuffer + lstrlen(m_FindReplaceData.lpstrFindWhat));
		m_edit.SendMessage(EM_SCROLLCARET, 0, 0);
		bFound = TRUE;
	}
	delete[] pBuffer;
	return bFound;
}

// u
BOOL CMainFrame::ReplaceText()
{
	// for safety
	if (m_FindReplaceData.lpstrFindWhat == NULL || m_FindReplaceData.lpstrFindWhat[0] == '\0') {
		return FALSE;
	}
	// for safety
	if (m_FindReplaceData.lpstrReplaceWith == NULL) {
		return FALSE;
	}
	BOOL bReplace = FALSE;
	BOOL bFound = FALSE;
	int nSelStart = -1;
	int nSelEnd = -1;
	int nStartChar, nEndChar;
	m_edit.GetSel(nStartChar, nEndChar);

	// ̂тɑSeLXg擾̂͌AvP
	DWORD dwBufferSize = m_edit.GetWindowTextLength();
	LPSTR pBuffer = new TCHAR[dwBufferSize + 1];
	m_edit.GetWindowText((LPTSTR)pBuffer, dwBufferSize + 1);
	pBuffer[dwBufferSize] = '\0';

	int nReplaceGap = 0;
	int nSelLength = nEndChar - nStartChar;
	if (nSelLength > 0) {
		LPSTR pszSelText = new TCHAR[nSelLength + 1];
		memcpy(pszSelText, pBuffer + nStartChar, nSelLength);
		pszSelText[nSelLength] = '\0';
		int result;
		if (m_FindReplaceData.Flags & FR_MATCHCASE) {
			result = StrCmp(pszSelText, m_FindReplaceData.lpstrFindWhat);
		} else {
			result = StrCmpI(pszSelText, m_FindReplaceData.lpstrFindWhat);
		}
		delete pszSelText;
		if (result == 0) {
			bReplace = TRUE;
			nSelStart = nStartChar;
			nSelEnd = nStartChar + lstrlen(m_FindReplaceData.lpstrReplaceWith);
			nReplaceGap = lstrlen(m_FindReplaceData.lpstrReplaceWith) - lstrlen(m_FindReplaceData.lpstrFindWhat);
		}
		nStartChar = nEndChar;
	}

	LPCTSTR pszFindStr;
	if (m_FindReplaceData.Flags & FR_MATCHCASE) {
		pszFindStr = StrStr(pBuffer + nStartChar, m_FindReplaceData.lpstrFindWhat);
	} else {
		pszFindStr = StrStrI(pBuffer + nStartChar, m_FindReplaceData.lpstrFindWhat);
	}
	if (pszFindStr != NULL) {
		nSelStart = pszFindStr - pBuffer + nReplaceGap;
		nSelEnd = nSelStart + lstrlen(m_FindReplaceData.lpstrFindWhat);
		bFound = TRUE;
	}
	if (bReplace) {
		m_edit.ReplaceSel(m_FindReplaceData.lpstrReplaceWith, TRUE);
	}
	if (nSelStart != -1) {
		m_edit.SetSel(nSelStart, nSelEnd);
		m_edit.SendMessage(EM_SCROLLCARET, 0, 0);
	}
	delete[] pBuffer;
	return bFound;
}

// Su
BOOL CMainFrame::ReplaceTextAll(int* pnReplaceCount)
{
	// for safety
	if (pnReplaceCount == NULL) {
		return FALSE;
	}
	// for safety
	if (m_FindReplaceData.lpstrFindWhat == NULL || m_FindReplaceData.lpstrFindWhat[0] == '\0') {
		return FALSE;
	}
	// for safety
	if (m_FindReplaceData.lpstrReplaceWith == NULL) {
		return FALSE;
	}
	SendMessage(g_hwndFindReplaceDlg, WM_CLOSE, 0, 0);
	g_hwndFindReplaceDlg = NULL;

	BOOL bFound = FALSE;
	int nStartChar, nEndChar;
	m_edit.GetSel(nStartChar, nEndChar);
	DWORD dwBufferSize = m_edit.GetWindowTextLength();
	LPSTR pBuffer = new TCHAR[dwBufferSize + 1];
	m_edit.GetWindowText((LPTSTR)pBuffer, dwBufferSize + 1);
	pBuffer[dwBufferSize] = '\0';

	LPCTSTR pszFindStr = m_FindReplaceData.lpstrFindWhat;
	int nFindStrLen = lstrlen(m_FindReplaceData.lpstrFindWhat);
	LPCTSTR pszReplaceStr = m_FindReplaceData.lpstrReplaceWith;
	int nReplaceStrLen = lstrlen(m_FindReplaceData.lpstrReplaceWith);

	int nReplaceCount = 0;
	try {
		int nPos = 0;
		CTextBuffer text;
		for (;;) {
			LPCTSTR pszFind;
			if (m_FindReplaceData.Flags & FR_MATCHCASE) {
				pszFind = StrStr(pBuffer + nPos, pszFindStr);
			} else {
				pszFind = StrStrI(pBuffer + nPos, pszFindStr);
			}
			if (pszFind == NULL) {
				text.WriteText(pBuffer + nPos);
				break;
			}
			int nOffset = pszFind - (pBuffer + nPos);
			if (nOffset > 0) {
				text.Write((BYTE*)(pBuffer + nPos), nOffset);
			}
			text.WriteText(pszReplaceStr);
			nPos += nOffset + nFindStrLen;
			++nReplaceCount;
		}
		if (nReplaceCount != 0) {
			text.WriteNull();
			m_edit.SetWindowText((LPCTSTR)text.GetBuffer());
			m_edit.SetSel(0, 0);
			m_edit.SendMessage(EM_SCROLLCARET, 0, 0);
		}
	}
	catch (std::bad_alloc) {
		// no memory
		return FALSE;
	}
	delete[] pBuffer;

	*pnReplaceCount = nReplaceCount;

	return bFound;
}

BOOL CMainFrame::RegularizeEnter(LPBYTE* ppBuffer, int* pdwBufferSize, BOOL* pbLFonly)
{
	LPBYTE p = *ppBuffer;
	int dwSize = *pdwBufferSize;

	BOOL bFindCRLF = FALSE;
	BOOL bLFonly = FALSE;
	int nLFonly = 0;
	int i;
	for (i = 0; i < dwSize; i++) {
		if (p[i] == '\r' && p[i+1] == '\n') {
			bFindCRLF = TRUE;
			i++;
		}
		else if (p[i] == '\n') {
			if (! bFindCRLF) {
				bLFonly = TRUE;
			}
			nLFonly++;
		}
	}
	if (nLFonly > 0) {
		int dwBufferSize = *pdwBufferSize + nLFonly;
		LPBYTE pBuffer = new BYTE[dwBufferSize + 1];
		int i, j;
		j = 0;
		for (i = 0; i < dwSize; i++) {
			if (p[i] == '\r' && p[i+1] == '\n') {
				pBuffer[j++] = p[i];
				pBuffer[j++] = p[i+1];
				i++;
			}
			else if (p[i] == '\n') {
				pBuffer[j++] = '\r';
				pBuffer[j++] = '\n';
			}
			else {
				pBuffer[j++] = p[i];
			}
		}
		pBuffer[j] = '\0';

		delete *ppBuffer;
		*ppBuffer = pBuffer;
		*pdwBufferSize = dwBufferSize;
	}
	*pbLFonly = bLFonly;
	return TRUE;
}

BOOL CMainFrame::MakeLFEnter(LPBYTE* ppBuffer, int* pdwBufferSize)
{
	LPBYTE p = *ppBuffer;
	int dwSize = *pdwBufferSize;

	int i;
	int j = 0;
	for (i = 0; i < dwSize; i++) {
		if (p[i] == '\r' && p[i+1] == '\n') {
			p[j++] = '\n';
			i++;
		}
		else {
			p[j++] = p[i];
		}
	}
	p[j] = '\0';
	*pdwBufferSize = j;
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////

// bZ[W\ (eLXg)
int CMainFrame::MessageBox(LPCTSTR pszText, UINT nType/*= MB_OK*/)
{
	return ::MessageBox(m_hWnd, pszText, KfxGetAppTitle(), nType);
}

// bZ[W\ (\[X)
int CMainFrame::MessageBox(UINT nID, UINT nType/*= MB_OK*/)
{
	TCHAR szMsg[1024];
	if (::ExLoadString(nID, szMsg, sizeof(szMsg)))
		return ::MessageBox(m_hWnd, szMsg, KfxGetAppTitle(), nType);
	return IDCANCEL;
}

// bZ[W\ (FindDlg ɕ\郁bZ[W)
int CMainFrame::FindDlgMessageBox(LPCTSTR pszText, UINT nType/*= MB_OK*/)
{
	return ::MessageBox(g_hwndFindReplaceDlg, pszText, KfxGetAppTitle(), nType);
}

