// ===========================================================================
// MainFrm.h
// main window
//
//                                                                    kanegon
// ===========================================================================

#if !defined(_MAINFRM_H_)
#define _MAINFRM_H_

#include "resource.h"
#include "ExControl.h"
#include "jresviewer.h"


extern CMainFrame* g_pMainFrame;


/////////////////////////////////////////////////////////////////////////////
// CExExEdit

class CMainFrame;

class CExExEdit : public CWindowImpl<CExExEdit>
{
public:
	DECLARE_WND_SUPERCLASS(NULL, "EDIT")

public:
	CMainFrame* m_pParent;

	void SetParent(CMainFrame* pParent) {
		m_pParent = pParent;
	}
public:
	BEGIN_MSG_MAP(CExExEdit)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
	MESSAGE_HANDLER(WM_CHAR, OnChar)
	MESSAGE_HANDLER(WM_KEYUP, OnKeyup)
	END_MSG_MAP()

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
		UnsubclassWindow(); 
		bHandled = FALSE;
		return 0;
	}
	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnKeyup(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
};

//////////////////////////////////////////////////////////////////////////////
// CMainFrame

class CMainFrame : public CWindowImpl<CMainFrame>
{
public:
	DECLARE_WND_CLASS_EX(NULL, 0, NULL)

private:
	BEGIN_MSG_MAP( CMainFrame )
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_SIZE, OnSize)
	MESSAGE_HANDLER(WM_MENUSELECT, OnMenuSelect)
	MESSAGE_HANDLER(WM_INITMENU, OnInitMenu)
	MESSAGE_HANDLER(WM_NOTIFY, OnNotify)
	MESSAGE_HANDLER(WM_CLOSE, OnClose)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_QUERYENDSESSION, OnQueryEndSession)
	MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkgnd)
	MESSAGE_HANDLER(WM_DROPFILES, OnDropFiles)
	MESSAGE_HANDLER(WM_OPENFILE_ON_STARTUP, OnOpenFileOnStart)
	MESSAGE_HANDLER(g_uFindMessage, OnFindMessage)

	MESSAGE_HANDLER(WM_UPDATECARETPOSITION, OnUpdateCaretPosition)
	MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
	MESSAGE_HANDLER(WM_CHAR, OnChar)
	MESSAGE_HANDLER(WM_KEYUP, OnKeyup)

	COMMAND_ID_HANDLER(ID_FILE_NEW, OnFileNew)
	COMMAND_ID_HANDLER(ID_FILE_OPEN, OnFileOpen)
	COMMAND_ID_HANDLER(ID_FILE_SAVE, OnFileSave)
	COMMAND_ID_HANDLER(ID_FILE_SAVE_AS, OnFileSaveAs)
	COMMAND_ID_HANDLER(ID_FILE_IMPORT, OnFileImport)
	COMMAND_ID_HANDLER(ID_FILE_EXPORT, OnFileExport)
	COMMAND_ID_HANDLER(ID_EDIT_UNDO, OnEditUndo)
	COMMAND_ID_HANDLER(ID_EDIT_CUT, OnEditCut)
	COMMAND_ID_HANDLER(ID_EDIT_COPY, OnEditCopy)
	COMMAND_ID_HANDLER(ID_EDIT_PASTE, OnEditPaste)
	COMMAND_ID_HANDLER(ID_EDIT_CLEAR, OnEditClear)
	COMMAND_ID_HANDLER(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	COMMAND_ID_HANDLER(ID_EDIT_FIND, OnEditFind)
	COMMAND_ID_HANDLER(ID_EDIT_FIND_PREV, OnEditFindPrev)
	COMMAND_ID_HANDLER(ID_EDIT_FIND_NEXT, OnEditFindNext)
	COMMAND_ID_HANDLER(ID_EDIT_REPLACE, OnEditReplace)
	COMMAND_ID_HANDLER(ID_EDIT_READONLY, OnEditReadOnly)
	COMMAND_ID_HANDLER(ID_TOOL_OPTION, OnToolOption)
	COMMAND_ID_HANDLER(ID_APP_EXIT, OnAppExit)
	COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
	COMMAND_HANDLER(IDW_EDIT, EN_CHANGE, OnChangeEdit)
	END_MSG_MAP()

public:
	CExEdit m_edit;
	CExExEdit m_edit2;
	CExToolbar m_toolbar;
	CExStatusBar m_statusbar;

	TCHAR m_szFileName[_MAX_PATH];
	BOOL m_bEnableFileName;
	BOOL m_bReadOnly;
	BOOL m_bLFonly;

	FINDREPLACE m_FindReplaceData;
	TCHAR m_szFindText[80];
	TCHAR m_szReplaceText[80];
	BOOL m_bEnableReplaceDlg;

public:
	CMainFrame();
	~CMainFrame();

public:
	HWND ExCreate();
	void RecalcLayout();
	void UpdateCaption();
	void SetFileName(LPCTSTR pszFileName);
	LPCTSTR GetFileName();
	void SetLFonly(BOOL bLFonly);
	BOOL GetLFonly();

	BOOL IsClipboardData();
	LPTSTR GetToolTipText(UINT nCmdID);
	void SetReadOnly(BOOL bEnable);
	BOOL GetReadOnly();
	BOOL FindText();
	BOOL ReplaceText();
	BOOL ReplaceTextAll(int* pnReplaceCount);
	BOOL RegularizeEnter(LPBYTE* ppBuffer, int* pdwBufferSize, BOOL* pbLFonly);
	BOOL MakeLFEnter(LPBYTE* ppBuffer, int* pdwBufferSize);

	void CreateNewFile();
	BOOL OpenExistFile(BOOL bNative = FALSE);
	BOOL OpenExistFileDirect(LPCTSTR pszPath, BOOL bNative = FALSE);
	BOOL SaveFile();
	BOOL SaveFileAs(BOOL bNative = FALSE);
	BOOL SaveFileDirect(LPCTSTR pszPath, BOOL bForce = TRUE, BOOL bNative =  FALSE);
	BOOL SaveFileWithAsk();

	int MessageBox(LPCTSTR pszText, UINT nType = MB_OK);
	int MessageBox(UINT nIDPrompt, UINT nType = MB_OK);
	int FindDlgMessageBox(LPCTSTR pszText, UINT nType = MB_OK);
//test
	void UpdateCaretPosition();

public:
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnMenuSelect(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnInitMenu(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnQueryEndSession(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnEraseBkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDropFiles(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnOpenFileOnStart(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	LRESULT OnUpdateCaretPosition(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnKeyup(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	LRESULT OnFindMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnFileNew(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileOpen(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileSave(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileSaveAs(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileImport(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileExport(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditUndo(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditCut(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditCopy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditPaste(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditClear(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditSelectAll(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditFind(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditFindPrev(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditFindNext(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditReplace(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnEditReadOnly(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnToolOption(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnAppExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnAppAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnChangeEdit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
};


#endif // _MAINFRM_H_
