// ===========================================================================
// OptionDlg.cpp
// option setting
//
//                                                                    kanegon
// ===========================================================================

#include "stdafx.h"
#include "jresviewer.h"
#include "common.h"
#include "Option.h"
#include "OptionDlg.h"


/////////////////////////////////////////////////////////////////////////////

static const TCHAR szDefaultProgramExtension[] = _T(".exe");


/////////////////////////////////////////////////////////////////////////////
// IvVݒ_CAO

// EBhE
LRESULT COptionDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	SendDlgItemMessage(IDC_OPTION_READONLYOPEN_CHECK, BM_SETCHECK, (KfxGetProfile()->GetReadOnlyOpen() ? BST_CHECKED : BST_UNCHECKED), 0);
	SendDlgItemMessage(IDC_OPTION_EXIT_BY_ESC_CHECK, BM_SETCHECK, (KfxGetProfile()->GetExitByESC() ? BST_CHECKED : BST_UNCHECKED), 0);
	SendDlgItemMessage(IDC_OPTION_USE_N2A_CHECK, BM_SETCHECK, (KfxGetProfile()->GetUseNative2Ascii() ? BST_CHECKED : BST_UNCHECKED), 0);
	SendDlgItemMessage(IDC_OPTION_N2A_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)KfxGetProfile()->GetNative2AsciiPath());

	ButtonStatusChanged();

	CenterWindow(GetParent());
	return TRUE;
}

// unative2ascii gpv`FbN
LRESULT COptionDlg::OnNative2AsciiCheck(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	ButtonStatusChanged();
	return 0;
}

// {^Ԃ̕ύX
void COptionDlg::ButtonStatusChanged()
{
	BOOL bNative2Ascii = (SendDlgItemMessage(IDC_OPTION_USE_N2A_CHECK, BM_GETCHECK) == BST_CHECKED) ? TRUE : FALSE;
	::EnableWindow(GetDlgItem(IDC_OPTION_N2A_PATH_LABEL), bNative2Ascii);
	::EnableWindow(GetDlgItem(IDC_OPTION_N2A_PATH_EDIT), bNative2Ascii);
	::EnableWindow(GetDlgItem(IDC_OPTION_N2A_REF_BUTTON), bNative2Ascii);
}

// [OK] {^
LRESULT COptionDlg::OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	KfxGetProfile()->SetReadOnlyOpen(SendDlgItemMessage(IDC_OPTION_READONLYOPEN_CHECK, BM_GETCHECK) == BST_CHECKED ? TRUE : FALSE);
	KfxGetProfile()->SetExitByESC(SendDlgItemMessage(IDC_OPTION_EXIT_BY_ESC_CHECK, BM_GETCHECK) == BST_CHECKED ? TRUE : FALSE);
	KfxGetProfile()->SetUseNative2Ascii(SendDlgItemMessage(IDC_OPTION_USE_N2A_CHECK, BM_GETCHECK) == BST_CHECKED ? TRUE : FALSE);
	TCHAR szPath[_MAX_PATH];
	SendDlgItemMessage(IDC_OPTION_N2A_PATH_EDIT, WM_GETTEXT, sizeof(szPath), (LPARAM)szPath);
	KfxGetProfile()->SetNative2AsciiPath(szPath);

	KfxGetProfile()->Write();

	EndDialog(IDOK);

	return 0;
}

// [LZ] {^
LRESULT COptionDlg::OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	EndDialog(IDCANCEL);

	return 0;
}

// [Q]{^
LRESULT COptionDlg::OnRefNative2Ascii(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	TCHAR szFilter[_MAX_PATH];
	::ExLoadString(IDS_FILEEXT_FILTER_PROGRAM, szFilter, sizeof(szFilter));

	TCHAR szPath[_MAX_PATH];
	if (ExGetOpenFileName(szPath, sizeof(szPath), &szDefaultProgramExtension[1],
			OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
			szFilter,
			m_hWnd, NULL, NULL)) {
		SendDlgItemMessage(IDC_OPTION_N2A_PATH_EDIT, WM_SETTEXT, 0, (LPARAM)szPath);
	}
	return 0;
}

