// ===========================================================================
// common.cpp
// common library
//
//                                                                    kanegon
// ===========================================================================

#include "stdafx.h"
#include <ctype.h>
#include "jresviewer.h"
#include "option.h"
#include "native2ascii.h"
#include "common.h"


//////////////////////////////////////////////////////////////////////////////
// t@C _CAO

BOOL ExGetOpenFileName(LPTSTR pszPath, DWORD dwMaxPath, LPCTSTR pszDefExt, DWORD dwFlags, LPCTSTR pszFilter, HWND hParent, LPCTSTR pszInitialDir, LPCTSTR pszTitle)
{
	TCHAR szPath[_MAX_PATH];
	TCHAR szFilter[_MAX_PATH];
	OPENFILENAME ofn;

	if (pszPath == NULL)
		return FALSE;

	memset(szPath, 0, sizeof(szPath));
	memset(szFilter, 0, sizeof(szFilter));
	memset(&ofn, 0, sizeof(ofn));

	if (pszFilter != NULL) {
		lstrcpy(szFilter, pszFilter);
		for (int i = 0; szFilter[i] != '\0'; i++)
			if (szFilter[i] == '|') szFilter[i] = '\0';
	}

	ofn.lStructSize = sizeof(ofn);
//	ofn.lStructSize = OPENFILENAME_SIZE_VERSION_400;
	ofn.hwndOwner = hParent;
	ofn.hInstance = _Module.GetModuleInstance();
	ofn.lpstrFilter = (szFilter[0] != '\0') ? szFilter : NULL;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = szPath;
	ofn.nMaxFile = sizeof(szPath);
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = pszInitialDir;
	ofn.lpstrTitle = pszTitle;
	ofn.Flags = dwFlags;
	ofn.nFileOffset = NULL;
	ofn.nFileExtension = NULL;
	ofn.lpstrDefExt = pszDefExt;
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	if (GetOpenFileName(&ofn)) {
		strcpy(pszPath, szPath);
		return TRUE;
	}
	return FALSE;
}

BOOL ExGetSaveFileName(LPTSTR pszPath, DWORD dwMaxPath, LPCTSTR pszDefExt, DWORD dwFlags, LPCTSTR pszFilter, HWND hParent, LPCTSTR pszInitialDir, LPCTSTR pszTitle)
{
	TCHAR szPath[_MAX_PATH];
	TCHAR szFilter[_MAX_PATH];
	OPENFILENAME ofn;

	if (pszPath == NULL)
		return FALSE;

	memset(szPath, 0, sizeof(szPath));
	memset(szFilter, 0, sizeof(szFilter));
	memset(&ofn, 0, sizeof(ofn));

	if (pszFilter != NULL) {
		lstrcpy(szFilter, pszFilter);
		for (int i = 0; szFilter[i] != '\0'; i++)
			if (szFilter[i] == '|') szFilter[i] = '\0';
	}

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hParent;
	ofn.hInstance = _Module.GetModuleInstance();
	ofn.lpstrFilter = (szFilter[0] != '\0') ? szFilter : NULL;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = szPath;
	ofn.nMaxFile = sizeof(szPath);
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = pszInitialDir;
	ofn.lpstrTitle = pszTitle;
	ofn.Flags = dwFlags;
	ofn.nFileOffset = NULL;
	ofn.nFileExtension = NULL;
	ofn.lpstrDefExt = pszDefExt;
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	if (GetSaveFileName(&ofn)) {
		strcpy(pszPath, szPath);
		return TRUE;
	}
	return FALSE;
}

BOOL ExReadFile(LPCTSTR pszPath, LPBYTE* ppBuffer, DWORD* pdwBufferSize)
{
	if (pszPath == NULL || ppBuffer == NULL || pdwBufferSize == NULL)
		return FALSE;
	*ppBuffer = NULL;
	*pdwBufferSize = 0;

	HANDLE hFile = ::CreateFile(pszPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	DWORD dwSize = GetFileSize(hFile, NULL);
	if (dwSize == 0xFFFFFFFF) {
		CloseHandle(hFile);
		return FALSE;
	}
	LPBYTE pBuffer = new BYTE[dwSize + 1];
	DWORD dwRead = 0;
	if (dwSize != 0) {
		BOOL bResult = ReadFile(hFile, pBuffer, dwSize, &dwRead, NULL);
		if (! bResult || dwSize != dwRead) {
			delete[] pBuffer;
			CloseHandle(hFile);
			return FALSE;
		}
	}
	CloseHandle(hFile);
	pBuffer[dwSize] = '\0';

	*ppBuffer = pBuffer;
	*pdwBufferSize = dwSize;

	return TRUE;
}

BOOL ExWriteFile(LPCTSTR pszPath, LPBYTE pBuffer, DWORD dwBufferSize)
{
	if (pszPath == NULL || pBuffer == NULL)
		return FALSE;
	if (dwBufferSize == 0)
		return TRUE;

	HANDLE hFile = ::CreateFile(pszPath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	DWORD dwWrote = 0;
	BOOL bResult = ::WriteFile(hFile, pBuffer, dwBufferSize, &dwWrote, NULL);
	if (! bResult || dwBufferSize != dwWrote) {
		::CloseHandle(hFile);
		return FALSE;
	}
	::CloseHandle(hFile);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////

#define IsShiftJisLead(c)  (((BYTE)(c) >= 0x81 && (BYTE)(c) <= 0x9F) || ((BYTE)(c) >= 0xE0 && (BYTE)(c) <= 0xFC))
#define IsShiftJisTrail(c) (((BYTE)(c) >= 0x40 && (BYTE)(c) <= 0x7E) || ((BYTE)(c) >= 0x80 && (BYTE)(c) <= 0xFC))

static int ToHexChar(int n)
{
	if (n >= 10) {
		return 'a' + (n - 10);
	} else {
		return '0' + n;
	}
}

// GXP[v
BOOL UnicodeEscape(LPTSTR* ppBuffer, int* pnBufferSize)
{
	LPTSTR pBuffer = *ppBuffer;
	int nBufferSize = *pnBufferSize;

	// ʓ|Ȃ̂ 6{(ő)̗̈ŏm
	// AdlύXA{ȊOȂǂ̊֌W6{ȏ̗̈悪Kvȉ\Δj]
	int nNewSize = nBufferSize * 6;	// 
	LPTSTR pNewBuffer = new TCHAR[nNewSize];

	int nSrcOffset = 0;
	int nDstOffset = 0;
	for (nSrcOffset = 0; nSrcOffset < nBufferSize;) {
		if ((BYTE)pBuffer[nSrcOffset] >= 0x80) {
			if ((nBufferSize - nSrcOffset) >= 2 &&
				IsShiftJisLead(pBuffer[nSrcOffset]) && IsShiftJisTrail(pBuffer[nSrcOffset+1])) {
				char MultiByteChar[3];
				MultiByteChar[0] = pBuffer[nSrcOffset];
				MultiByteChar[1] = pBuffer[nSrcOffset + 1];
				MultiByteChar[2] = '\0';
				wchar_t WideChar[3];
				int nWideSize = MultiByteToWideChar(CP_ACP, 0, MultiByteChar, 2, NULL, 0);
				MultiByteToWideChar(CP_ACP, 0, MultiByteChar, 2, WideChar, nWideSize + 1);
				pNewBuffer[nDstOffset++] = '\\';
				pNewBuffer[nDstOffset++] = 'u';
				pNewBuffer[nDstOffset++] = ToHexChar((((BYTE*)WideChar)[1] >> 4) & 0x0f);
				pNewBuffer[nDstOffset++] = ToHexChar(((BYTE*)WideChar)[1] & 0x0f);
				pNewBuffer[nDstOffset++] = ToHexChar((((BYTE*)WideChar)[0] >> 4) & 0x0f);
				pNewBuffer[nDstOffset++] = ToHexChar(((BYTE*)WideChar)[0] & 0x0f);
				nSrcOffset += 2;
			} else {
				char MultiByteChar[2];
				MultiByteChar[0] = pBuffer[nSrcOffset];
				MultiByteChar[1] = '\0';
				wchar_t WideChar[3];
				int nWideSize = MultiByteToWideChar(CP_ACP, 0, MultiByteChar, 1, NULL, 0);
				MultiByteToWideChar(CP_ACP, 0, MultiByteChar, 1, WideChar, nWideSize + 1);
				pNewBuffer[nDstOffset++] = '\\';
				pNewBuffer[nDstOffset++] = 'u';
				pNewBuffer[nDstOffset++] = ((BYTE*)WideChar)[2];
				pNewBuffer[nDstOffset++] = ((BYTE*)WideChar)[3];
				pNewBuffer[nDstOffset++] = ((BYTE*)WideChar)[0];
				pNewBuffer[nDstOffset++] = ((BYTE*)WideChar)[1];
				nSrcOffset += 1;
			}
		} else {
			pNewBuffer[nDstOffset] = pBuffer[nSrcOffset];
			++nSrcOffset;
			++nDstOffset;
		}
	}
	pNewBuffer[nDstOffset] = '\0';
	*ppBuffer = pNewBuffer;
	*pnBufferSize = nDstOffset;
	delete[] pBuffer;
	return TRUE;
}

// GXP[v`FbN
static BOOL IsEscapeChar(LPTSTR pBuffer, int nLen)
{
	if (nLen < 6) {
		return FALSE;
	}
	if (pBuffer[0] == '\\' &&
		pBuffer[1] == 'u' &&
		isxdigit(pBuffer[2]) &&
		isxdigit(pBuffer[3]) &&
		isxdigit(pBuffer[4]) &&
		isxdigit(pBuffer[5])) {
		return TRUE;
	}
	return FALSE;
}

// GXP[v
BOOL UnicodeUnescape(LPTSTR* ppBuffer, int* pnBufferSize)
{
	LPTSTR pBuffer = *ppBuffer;
	int nBufferSize = *pnBufferSize;

	// ܂͂Ȃ̂œTCŸ̗m
	int nNewSize = nBufferSize;	// 
	LPTSTR pNewBuffer = new TCHAR[nNewSize + 1];

	int nSrcOffset = 0;
	int nDstOffset = 0;
	for (nSrcOffset = 0; nSrcOffset < nBufferSize;) {
		if (IsEscapeChar(&pBuffer[nSrcOffset], nBufferSize - nSrcOffset)) {
			BYTE WideChar[4];
			WideChar[0] = ((isdigit(pBuffer[nSrcOffset+4]) ? pBuffer[nSrcOffset+4] - '0' : toupper(pBuffer[nSrcOffset+4]) - 'A' + 10) << 4) + 
						(isdigit(pBuffer[nSrcOffset+5]) ? pBuffer[nSrcOffset+5] - '0' : toupper(pBuffer[nSrcOffset+5]) - 'A' + 10);
			WideChar[1] = ((isdigit(pBuffer[nSrcOffset+2]) ? pBuffer[nSrcOffset+2] - '0' : toupper(pBuffer[nSrcOffset+2]) - 'A' + 10) << 4) + 
						(isdigit(pBuffer[nSrcOffset+3]) ? pBuffer[nSrcOffset+3] - '0' : toupper(pBuffer[nSrcOffset+3]) - 'A' + 10);
			WideChar[2] = '\0';
			WideChar[3] = '\0';
			char MultiByteChar[4];
			int nNativeSize = WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)WideChar, 1, NULL, 0, NULL, NULL);
			WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)WideChar, 1, MultiByteChar, nNativeSize + 1, NULL, NULL);
			for (int i = 0; i < nNativeSize; i++) {
				pNewBuffer[nDstOffset++] = MultiByteChar[i];
			}
			nSrcOffset += 6;
		} else {
			pNewBuffer[nDstOffset] = pBuffer[nSrcOffset];
			++nSrcOffset;
			++nDstOffset;
		}
	}
	pNewBuffer[nDstOffset] = '\0';
	*ppBuffer = pNewBuffer;
	*pnBufferSize = nDstOffset;
	delete[] pBuffer;
	return TRUE;
}

BOOL UnicodeEscapeByNative2Ascii(LPTSTR* ppBuffer, int* pnBufferSize, LPTSTR pszErrMsg, DWORD dwErrMsgBufferSize)
{
	LPCTSTR szCmdLine = KfxGetProfile()->GetNative2AsciiPath();

	LPTSTR pBuffer = *ppBuffer;
	int nBufferSize = *pnBufferSize;

	CNative2Ascii n2a;
	if (! n2a.Native2Ascii(szCmdLine, (BYTE*)pBuffer, nBufferSize)) {
		// error
		if (pszErrMsg != NULL) {
			lstrcpyn(pszErrMsg, n2a.GetErrorMsg(), dwErrMsgBufferSize);
		}
		return FALSE;
	}

	LPTSTR pszNewBuffer = new TCHAR[n2a.GetOutputBufferSize()];
	lstrcpy(pszNewBuffer, (LPCTSTR)n2a.GetOutputBuffer());

	delete[] *ppBuffer;

	*ppBuffer = pszNewBuffer;
	*pnBufferSize = n2a.GetOutputBufferSize();

	return TRUE;
}

BOOL UnicodeUnescapeByNative2Ascii(LPTSTR* ppBuffer, int* pnBufferSize, LPTSTR pszErrMsg, DWORD dwErrMsgBufferSize)
{
	LPCTSTR szCmdLine = KfxGetProfile()->GetNative2AsciiPath();

	LPTSTR pBuffer = *ppBuffer;
	int nBufferSize = *pnBufferSize;

	CNative2Ascii n2a;
	if (! n2a.Ascii2Native(szCmdLine, (BYTE*)pBuffer, nBufferSize)) {
		// error
		if (pszErrMsg != NULL) {
			lstrcpyn(pszErrMsg, n2a.GetErrorMsg(), dwErrMsgBufferSize);
		}
		return FALSE;
	}

	LPTSTR pszNewBuffer = new TCHAR[n2a.GetOutputBufferSize() + 1];
	lstrcpy(pszNewBuffer, (LPCTSTR)n2a.GetOutputBuffer());

	delete[] *ppBuffer;

	*ppBuffer = pszNewBuffer;
	*pnBufferSize = n2a.GetOutputBufferSize();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////

BOOL IsWildcardFileName(LPCTSTR pszPath)
{
	if (strchr(pszPath, '*') != NULL ||
		strchr(pszPath, '?') != NULL) {
		return TRUE;
	}
	return FALSE;
}

BOOL IsFile(LPCTSTR pszPath)
{
	if (! PathFileExists(pszPath)) {
		return FALSE;
	}
	if (PathIsDirectory(pszPath)) {
		return FALSE;
	}
	return TRUE;
}

BOOL IsMatchExtension(LPCTSTR pszPath, LPCTSTR pszExtension)
{
	// gq ".xxx" ̂悤 '.' tŎw肷邱
	int nExtLen = lstrlen(pszExtension);
	int nLen = lstrlen(pszPath);
	if (nLen <= nExtLen) {
		return FALSE;
	}
	if (lstrcmpi(&pszPath[nLen - nExtLen], pszExtension) == 0) {
		return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////

BOOL ExLoadString(UINT nID, LPTSTR pBuffer, int nBufferSize)
{
	if (pBuffer == NULL)
		return FALSE;
	pBuffer[0] = '\0';
	if (::LoadString(_Module.GetResourceInstance(), nID, pBuffer, nBufferSize)) {
//ATLTRACE("LoadResource(%d) = \"%s\")\n", nID, pBuffer);
		return TRUE;
	}
//ATLTRACE("LoadResource(%d) failed\n", nID);
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////////
// WXg

// eLXgǍ
BOOL ReadRegText(LPCTSTR pszRegKey, LPCTSTR pszRegName, LPTSTR pszValue, DWORD dwValueSize, LPCTSTR pszDefault)
{
	HKEY hKey;

	LONG lResult = RegOpenKeyEx(HKEY_CURRENT_USER, pszRegKey, 0, KEY_ALL_ACCESS, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD dwReadSize = dwValueSize;
		DWORD dwType = 0;
		lResult = RegQueryValueEx(hKey, pszRegName, NULL, &dwType, (LPBYTE)pszValue, &dwReadSize);
		RegCloseKey(hKey);
		if (lResult == ERROR_SUCCESS &&
			dwType == REG_SZ) {
			return TRUE;
		}
	}
	strcpy(pszValue, pszDefault);
	return TRUE;
}

// lǍ
BOOL ReadRegInt(LPCTSTR pszRegKey, LPCTSTR pszRegName, DWORD* pdwValue, DWORD dwDefaultValue)
{
	HKEY hKey;

	LONG lResult = RegOpenKeyEx(HKEY_CURRENT_USER, pszRegKey, 0, KEY_ALL_ACCESS, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD dwReadSize = sizeof(DWORD);
		DWORD dwType = 0;
		lResult = RegQueryValueEx(hKey, pszRegName, NULL, &dwType, (LPBYTE)pdwValue, &dwReadSize);
		RegCloseKey(hKey);
		if (lResult == ERROR_SUCCESS &&
			dwType == REG_DWORD) {
			return TRUE;
		}
	}
	*pdwValue = dwDefaultValue;
	return TRUE;
}

// eLXg
VOID WriteRegText(LPCTSTR pszRegKey, LPCTSTR pszRegName, LPCTSTR pszValue)
{
	HKEY hKey;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, pszRegKey, 0, "", REG_OPTION_NON_VOLATILE,
				KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS) {
		RegSetValueEx(hKey, pszRegName, 0, REG_SZ, (LPBYTE)pszValue, lstrlen(pszValue) + 1);
		RegCloseKey(hKey);
	}
}

// l
VOID WriteRegInt(LPCTSTR pszRegKey, LPCTSTR pszRegName, DWORD dwValue)
{
	HKEY hKey;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, pszRegKey, 0, "", REG_OPTION_NON_VOLATILE,
				KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS) {
		RegSetValueEx(hKey, pszRegName, 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));
		RegCloseKey(hKey);
	}
}

//////////////////////////////////////////////////////////////////////////////
// OS 

#define OSTYPE_UNKNOWN  0
#define OSTYPE_9X       1 // 95,98,Me
#define OSTYPE_NT4      2 // NT4
#define OSTYPE_2000     3 // 2000
#define OSTYPE_XP       4 // XP or 2003 or later

#define OSTYPE_9X_UNKNOWN  0
#define OSTYPE_9X_95       1
#define OSTYPE_9X_95OSR2   2
#define OSTYPE_9X_98       3
#define OSTYPE_9X_98SE     4
#define OSTYPE_9X_ME       5

static DWORD s_dwOSType = OSTYPE_UNKNOWN;
static DWORD s_dw9xDescription = OSTYPE_9X_UNKNOWN;

// check OS type
static BOOL CheckOSType()
{
	OSVERSIONINFO os;
	ZeroMemory(&os, sizeof(os));
	os.dwOSVersionInfoSize = sizeof(os);

	s_dwOSType = OSTYPE_UNKNOWN;
	if (GetVersionEx(&os)) {
		switch (os.dwPlatformId) {
		case VER_PLATFORM_WIN32_NT:
			if (os.dwMajorVersion >= 5) {
				if (os.dwMajorVersion > 5 || os.dwMinorVersion >= 1) {
					s_dwOSType = OSTYPE_XP;  // XP or later
				} else {
					s_dwOSType = OSTYPE_2000;
				}
			} else {
				s_dwOSType = OSTYPE_NT4;
			}
			break;
		case VER_PLATFORM_WIN32_WINDOWS:
			s_dwOSType = OSTYPE_9X;
			if (os.dwMajorVersion == 4 && os.dwMinorVersion == 0) {
				// 95
				s_dw9xDescription = OSTYPE_9X_95;
				if (os.szCSDVersion[1] == 'C' || os.szCSDVersion[1] == 'B') {
					// OSR2
					s_dw9xDescription = OSTYPE_9X_95OSR2;
				}
			}
			if (os.dwMajorVersion == 4 && os.dwMinorVersion == 10) {
				// 98
				s_dw9xDescription = OSTYPE_9X_98;
				if (os.szCSDVersion[1] == 'A') {
					// SE
					s_dw9xDescription = OSTYPE_9X_98SE;
				}
			}
			if (os.dwMajorVersion == 4 && os.dwMinorVersion == 90) {
				// Me
				s_dw9xDescription = OSTYPE_9X_ME;
			}
			break;
		}
	}
	if (s_dwOSType == OSTYPE_UNKNOWN) {
		return FALSE;
	}
	return TRUE;
}

// check Windows NT Platform
BOOL IsWinNT()
{
	if (s_dwOSType == OSTYPE_UNKNOWN) {
		CheckOSType();
	}
	return (s_dwOSType == OSTYPE_NT4 || s_dwOSType == OSTYPE_2000 || s_dwOSType == OSTYPE_XP);
}

// check Windows 2000 or later
BOOL IsWin2K()
{
	if (s_dwOSType == OSTYPE_UNKNOWN) {
		CheckOSType();
	}
	return (s_dwOSType == OSTYPE_2000 || s_dwOSType == OSTYPE_XP);
}

// check Windows XP or later
BOOL IsWinXP()
{
	if (s_dwOSType == OSTYPE_UNKNOWN) {
		CheckOSType();
	}
	return (s_dwOSType == OSTYPE_XP);
}
