// ===========================================================================
// common.h
// common library
//
//                                                                    kanegon
// ===========================================================================

#if !defined(__COMMON_H_)
#define __COMMON_H_


//////////////////////////////////////////////////////////////////////////////

BOOL ExGetOpenFileName(LPTSTR pszPath, DWORD dwMaxPath, LPCTSTR pszDefExt = NULL, DWORD dwFlags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, LPCTSTR pszFilter = NULL, HWND hParent = NULL, LPCTSTR pszInitialDir = NULL, LPCTSTR pszTitle = NULL);
BOOL ExGetSaveFileName(LPTSTR pszPath, DWORD dwMaxPath, LPCTSTR pszDefExt = NULL, DWORD dwFlags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, LPCTSTR pszFilter = NULL, HWND hParent = NULL, LPCTSTR pszInitialDir = NULL, LPCTSTR pszTitle = NULL);

BOOL ExReadFile(LPCTSTR pszPath, LPBYTE* ppBuffer, DWORD* pdwBufferSize);
BOOL ExWriteFile(LPCTSTR pszPath, LPBYTE pBuffer, DWORD dwBufferSize);

BOOL UnicodeEscape(LPTSTR* ppBuffer, int* pnBufferSize);
BOOL UnicodeUnescape(LPTSTR* ppBuffer, int* pnBufferSize);

BOOL UnicodeEscapeByNative2Ascii(LPTSTR* ppBuffer, int* pnBufferSize, LPTSTR pszErrMsg, DWORD dwErrMsgBufferSize);
BOOL UnicodeUnescapeByNative2Ascii(LPTSTR* ppBuffer, int* pnBufferSize, LPTSTR pszErrMsg, DWORD dwErrMsgBufferSize);


//////////////////////////////////////////////////////////////////////////////

BOOL ExLoadString(UINT nID, LPTSTR pBuffer, int nBufferSize);


//////////////////////////////////////////////////////////////////////////////

BOOL ReadRegText(LPCTSTR pszRegKey, LPCTSTR pszRegName, LPTSTR pszValue, DWORD dwValueSize, LPCTSTR pszDefault);
BOOL ReadRegInt(LPCTSTR pszRegKey, LPCTSTR pszRegName, DWORD* pdwValue, DWORD dwDefaultValue);
VOID WriteRegText(LPCTSTR pszRegKey, LPCTSTR pszRegName, LPCTSTR pszValue);
VOID WriteRegInt(LPCTSTR pszRegKey, LPCTSTR pszRegName, DWORD dwValue);


//////////////////////////////////////////////////////////////////////////////

BOOL IsFile(LPCTSTR pszPath);
BOOL IsMatchExtension(LPCTSTR pszPath, LPCTSTR pszExtension);


//////////////////////////////////////////////////////////////////////////////

BOOL IsWinNT();
BOOL IsWin2K();
BOOL IsWinXP();


//////////////////////////////////////////////////////////////////////////////

#endif // __COMMON_H_
