// ===========================================================================
// n2a.cpp
// JDK native2ascii wrapper
//
//                                                                    kanegon
// ===========================================================================

#include "stdafx.h"
#include "common.h"
#include "resource.h"
#include "native2ascii.h"

//
// usage: native2ascii [options] [inputfile [outputfile]]
//
// -reverse
// t̏s܂B ܂ALatin-1 ܂ Unicode R[h̃t@ClC
// eBuR[h̃t@Cɕϊ܂B
//
// -encoding encoding_name
// ϊŎgpR[h̖Ow肵܂B ftHg̃R[h́AVXe
// vpeB file.encoding 擾܂B encoding_name ́AuT
// |[gĂGR[fBOvhLgɎĂAT|[g
// GR[fBO̕\̍ŏ̗񂩂擾Kv܂B
//
// -Joption
// Java z}V option n܂Boption ɂ́AuJava AvP[VN
// c[ṽt@Xy[WɋLڂĂIvV 1 w肵܂B
// Ƃ΁A-J-Xms48m Ǝw肷ƁAX^[gAbv 48M oCgɐݒ肳
// ܂B
//
// [[undocumented]]
// inputfile, outputfile p^Ŏw肷ɕWo͂ƂĂ
// \B
// ł́AoCił͔Ȃ݂B(0x00-0xff̃R[h
// ϊĂ݂)
// AsR[h 0x0d+0x0a ɐKĂ܂̂ƁAŌɂ 0x0d+0x0a
// t݂B
// unicode̎ʂȂǂsĂȂ݂B
//


//////////////////////////////////////////////////////////////////////////////

void Trim(LPTSTR pszText)
{
	if (pszText == NULL) {
		return;
	}
	int nIndex = 0;
	while (pszText[nIndex] != '\0' &&
		isspace(pszText[nIndex])) {
		++nIndex;
	}
	if (pszText[nIndex] == '\0') {
		pszText[0] = '\0';
		return;
	}
	int nStartValidChar = nIndex;
	int nEndValidChar = nIndex;
	while (pszText[nIndex] != '\0') {
		if (! isspace(pszText[nIndex])) {
			nEndValidChar = nIndex;
		}
		++nIndex;
	}
	int nLen = nEndValidChar - nStartValidChar + 1;
	if (nStartValidChar != 0) {
		memmove(pszText, &pszText[nStartValidChar], nLen);
	}
	pszText[nLen] = '\0';
}

//////////////////////////////////////////////////////////////////////////////

CNative2Ascii::CNative2Ascii()
{
	m_pszCmdLine = NULL;
	m_szAppPath[0] = '\0';
	m_szAppParam[0] = '\0';
	m_szAdditionParam[0] = '\0';
	m_pInputBuffer = NULL;
	m_dwInputBufferSize = 0;
	m_pOutputBuffer = NULL;
	m_dwOutputBufferSize = 0;
	m_dwErrorCode = 0;
	m_dwSysErrorCode = 0;
}

CNative2Ascii::~CNative2Ascii()
{
	if (m_pOutputBuffer != NULL) {
		delete[] m_pOutputBuffer;
	}
}

//////////////////////////////////////////////////////////////////////////////
// R}hs
// W͂ѕWo͂̃nhOn

BOOL CNative2Ascii::ExecCommandWithStdio(LPCTSTR pszCmdLine, HANDLE hInput, HANDLE hOutput)
{
	// CreateProcess  const 𒼐ړnƎs݂(by MSDN)Ȃ̂
	// [Jobt@ɃRs[ď
	// ŝ CreateProcessW ݂Ô
	TCHAR szCmdLine[EXECCMD_CMDLINE_BUFFER_SIZE];
	if (pszCmdLine == NULL ||
		lstrlen(pszCmdLine) >= sizeof(szCmdLine)) {
		SetErrorCode(EXECCMD_BAD_PARAMETER);
		return FALSE;
	}
	lstrcpy(szCmdLine, pszCmdLine);

	STARTUPINFO si;
	ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	si.dwFlags = STARTF_USESTDHANDLES;
	si.hStdInput = (HANDLE)hInput;
	si.hStdOutput = (HANDLE)hOutput;
	si.hStdError = (HANDLE)NULL;

	PROCESS_INFORMATION pi;
	BOOL bResult = CreateProcess(
					NULL,
					szCmdLine,
					NULL,
					NULL,
					TRUE,
					DETACHED_PROCESS,
					NULL,
					NULL,
					&si,
					&pi
					);
	if (bResult == FALSE) {
		SetErrorCode(EXECCMD_CREATEPROCESS_FAILED, GetLastError());
		return FALSE;
	}
	CloseHandle(pi.hThread);
	// vZX̏I҂
	WaitForSingleObject(pi.hProcess, INFINITE);
	DWORD dwExitCode = 0;
	bResult = GetExitCodeProcess(pi.hProcess, &dwExitCode);
	if (! bResult || dwExitCode == STILL_ACTIVE) {
		// IR[h擾s
		DWORD dwLastError = 0;
		if (! bResult) {
			dwLastError = GetLastError();
		}
		CloseHandle(pi.hProcess);
		SetErrorCode(EXECCMD_GETEXITCODE_FAILED, dwLastError);
		return FALSE;
	}
	CloseHandle(pi.hProcess);
	if (dwExitCode != 0) {
		// IR[h 0 ȊOُ͈Ƃ݂Ȃ
		SetErrorCode(EXECCMD_BAD_EXITCODE);
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
// R}hs
// W͂gpR}hĂяoAt@Cnh̑Ƀ
// p^ƂB
// ExecCommandWithStdio() ̃bpB
// W͂̓eœnAWo͂̌ʂŕԂB
// o͌ʂ̃obt@͓ŊlB

BOOL CNative2Ascii::ExecCommandWithMemory(LPCTSTR pszCmdLine)
{
	SECURITY_ATTRIBUTES sa;
	LPSECURITY_ATTRIBUTES lpsa = NULL;
	if (IsWinNT()) {
		ZeroMemory(&sa,sizeof(SECURITY_ATTRIBUTES));
		sa.nLength = sizeof(SECURITY_ATTRIBUTES);
		sa.bInheritHandle = TRUE;
		lpsa = &sa;
	}

	TCHAR szTmpDir[_MAX_PATH];
	GetTempPath(_MAX_PATH, szTmpDir);

	TCHAR szTmpPath1[_MAX_PATH];
	GetTempFileName(szTmpDir, "EXC", 0, szTmpPath1);
	HANDLE hOutput = CreateFile(szTmpPath1, GENERIC_READ | GENERIC_WRITE, 0, lpsa,
					CREATE_ALWAYS, FILE_ATTRIBUTE_TEMPORARY | FILE_FLAG_DELETE_ON_CLOSE, NULL);
	if (hOutput == INVALID_HANDLE_VALUE) {
		SetErrorCode(EXECCMD_TEMPORARY_IO_ERROR, GetLastError());
		return FALSE;
	}

	TCHAR szTmpPath2[_MAX_PATH];
	GetTempFileName(szTmpDir, "EXC", 0, szTmpPath2);
	HANDLE hInput = CreateFile(szTmpPath2, GENERIC_READ|GENERIC_WRITE, 0, lpsa,
					CREATE_ALWAYS, FILE_ATTRIBUTE_TEMPORARY | FILE_FLAG_DELETE_ON_CLOSE, NULL);
	if (hInput == INVALID_HANDLE_VALUE) {
		DWORD dwLastError = GetLastError();
		CloseHandle(hOutput);
		SetErrorCode(EXECCMD_TEMPORARY_IO_ERROR, dwLastError);
		return FALSE;
	}

	DWORD dwWrote;
	BOOL bResult = WriteFile(hInput, m_pInputBuffer, m_dwInputBufferSize, &dwWrote, NULL);
	if (! bResult) {
		DWORD dwLastError = GetLastError();
		CloseHandle(hInput);
		CloseHandle(hOutput);
		SetErrorCode(EXECCMD_TEMPORARY_IO_ERROR, dwLastError);
		return FALSE;
	}
	if (m_dwInputBufferSize != dwWrote) {
		CloseHandle(hInput);
		CloseHandle(hOutput);
		SetErrorCode(EXECCMD_TEMPORARY_IO_ERROR);
		return FALSE;
	}
	SetFilePointer(hInput, 0, NULL, FILE_BEGIN);

	bResult = ExecCommandWithStdio(pszCmdLine, hInput, hOutput);
	CloseHandle(hInput);
	if (! bResult) {
		CloseHandle(hOutput);
		return FALSE;
	}

	DWORD dwSize = SetFilePointer(hOutput, 0, NULL, FILE_END);
	SetFilePointer(hOutput, 0, NULL, FILE_BEGIN);
	BYTE* pReadBuffer = new BYTE[dwSize + 1];
	if (pReadBuffer == NULL) {
		CloseHandle(hOutput);
		SetErrorCode(EXECCMD_NO_MEMORY);
		return FALSE;
	}
	if (dwSize != 0) {
		DWORD dwReadSize;
		BOOL bResult = ReadFile(hOutput, pReadBuffer, dwSize, &dwReadSize, NULL);
		CloseHandle(hOutput);
		DWORD dwLastError = 0;
		if (! bResult) {
			dwLastError = GetLastError();
		} else if (dwSize != dwReadSize) {
			bResult = FALSE;
		}
		if (! bResult) {
			delete[] pReadBuffer;
			pReadBuffer = NULL;
			SetErrorCode(EXECCMD_TEMPORARY_IO_ERROR, dwLastError);
			return FALSE;
		}
		pReadBuffer[dwSize] = '\0';
	} else {
		pReadBuffer[dwSize] = '\0';
		CloseHandle(hOutput);
	}
	if (pReadBuffer != NULL) {
		m_pOutputBuffer = pReadBuffer;
		m_dwOutputBufferSize = dwSize;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
/*
p^

1) trim
2) 擪 '"'
    '"' ܂łR}hǍ낪p^
3) 擪 '"' ł͂Ȃ
   󔒂܂łR}hǍ낪p^

̔F͍͂ĂȂ
*/

BOOL CNative2Ascii::SetCmdLine(LPCTSTR pszCmdLine)
{
	m_pszCmdLine = NULL;
	m_szAppPath[0] = '\0';
	m_szAppParam[0] = '0';

	TCHAR szCmdLine[EXECCMD_CMDLINE_BUFFER_SIZE];
	TCHAR szAppPath[EXECCMD_CMDLINE_BUFFER_SIZE];
	TCHAR szAppParam[EXECCMD_CMDLINE_BUFFER_SIZE];

	if (lstrlen(pszCmdLine) >= EXECCMD_CMDLINE_BUFFER_SIZE) {
		SetErrorCode(EXECCMD_BAD_CMDLINE);
		return FALSE;
	}

	lstrcpy(szCmdLine, pszCmdLine);
	Trim(szCmdLine);
	if (lstrlen(szCmdLine) == 0) {
		SetErrorCode(EXECCMD_BAD_CMDLINE);
		return FALSE;
	}

	lstrcpy(szAppPath, szCmdLine);
	PathRemoveArgs(szAppPath);
	LPCTSTR pszArgs = PathGetArgs(szCmdLine);
	lstrcpy(szAppParam, pszArgs);
	Trim(szAppPath);
	Trim(szAppParam);

	if (lstrlen(szAppPath) == 0) {
		SetErrorCode(EXECCMD_BAD_CMDLINE);
		return FALSE;
	}
	// gqȂ .exe ⊮
	PathAddExtension(szAppPath, ".exe");

	if (PathIsRelative(szAppPath)) {
		// R}h͑΃pX
		SetErrorCode(EXECCMD_NO_ABSOLUTE_PATH);
		return FALSE;
	}
	if (! IsFile(szAppPath)) {
		// R}hȂ
		SetErrorCode(EXECCMD_CMD_NOT_FOUND);
		return FALSE;
	}
	m_pszCmdLine = pszCmdLine;
	lstrcpy(m_szAppPath, szAppPath);
	lstrcpy(m_szAppParam, szAppParam);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
// Native2Ascii

BOOL CNative2Ascii::Native2Ascii(LPCTSTR pszCmdLine, BYTE* pszSrc, DWORD dwSrcSize)
{
	m_pInputBuffer = pszSrc;
	m_dwInputBufferSize = dwSrcSize;
	if (! ExecCommandWithMemory(pszCmdLine)) {
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
// Ascii2Native

BOOL CNative2Ascii::Ascii2Native(LPCTSTR pszCmdLine, BYTE* pszSrc, DWORD dwSrcSize)
{
	TCHAR szCmdLine[EXECCMD_CMDLINE_BUFFER_SIZE];
	lstrcpy(szCmdLine, pszCmdLine);
	lstrcat(szCmdLine, " -reverse");
	m_pInputBuffer = pszSrc;
	m_dwInputBufferSize = dwSrcSize;
	if (! ExecCommandWithMemory(szCmdLine)) {
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////

LPCTSTR CNative2Ascii::GetErrorMsg() {
	TCHAR szRes[EXECCMD_ERROR_MSG_BUFFER_SIZE];
	switch (m_dwErrorCode) {
	case EXECCMD_SUCCESS:
		lstrcpy(m_szMsg, "");
		break;
	case EXECCMD_BAD_PARAMETER:
		// "p^ُłB"
		::ExLoadString(IDS_EXECCMD_BAD_PARAMETER, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes);
		break;
	case EXECCMD_TEMPORARY_IO_ERROR:
		// "e|t@C̓o̓G[łB[code=%d]"
		::ExLoadString(IDS_EXECCMD_TEMPORARY_IO_ERROR, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes, m_dwSysErrorCode);
		break;
	case EXECCMD_CREATEPROCESS_FAILED:
		// "OR}ȟĂяoɎs܂B[code=%d]"
		::ExLoadString(IDS_EXECCMD_CREATEPROCESS_FAILED, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes, m_dwSysErrorCode);
		break;
	case EXECCMD_GETEXITCODE_FAILED:
		// "IR[h̎擾Ɏs܂B[code=%d]"
		::ExLoadString(IDS_EXECCMD_GETEXITCODE_FAILED, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes, m_dwSysErrorCode);
		break;
	case EXECCMD_BAD_EXITCODE:
		// "OR}hG[ŏI܂B"
		::ExLoadString(IDS_EXECCMD_BAD_EXITCODE, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes);
		break;
	case EXECCMD_NO_MEMORY:
		// "słB"
		::ExLoadString(IDS_EXECCMD_NO_MEMORY, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes);
		break;
	case EXECCMD_BAD_CMDLINE:
		// "OR}h̎wɌ肪܂B"
		::ExLoadString(IDS_EXECCMD_BAD_CMDLINE, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes);
		break;
	case EXECCMD_NO_ABSOLUTE_PATH:
		// "OR}h΃pXł͂܂B"
		::ExLoadString(IDS_EXECCMD_NO_ABSOLUTE_PATH, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes);
		break;
	case EXECCMD_CMD_NOT_FOUND:
		// "w肳ꂽpXɊOR}h܂B"
		::ExLoadString(IDS_EXECCMD_CMD_NOT_FOUND, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes);
		break;
	case EXECCMD_ERROR:
	default:
		// "\ʃG[łB"
		::ExLoadString(IDS_EXECCMD_ERROR, szRes, sizeof(szRes));
		wnsprintf(m_szMsg, sizeof(m_szMsg), szRes);
		break;
	}
	return m_szMsg;
}

