// ===========================================================================
// n2a.h
// native2ascii wrapper
//
//                                                                    kanegon
// ===========================================================================

#if !defined(_N2A_H_)
#define _N2A_H_

#include <windows.h>


#define EXECCMD_SUCCESS                 0  // 
#define EXECCMD_BAD_PARAMETER           1  // p^G[ (G[)
#define EXECCMD_TEMPORARY_IO_ERROR      2  // e|t@CIOG[
#define EXECCMD_CREATEPROCESS_FAILED    3  // vZX쐬s
#define EXECCMD_GETEXITCODE_FAILED      4  // IR[h擾s
#define EXECCMD_BAD_EXITCODE            5  // IR[hُ
#define EXECCMD_NO_MEMORY               6  // s
#define EXECCMD_BAD_CMDLINE             7  // R}h̎wɌ
#define EXECCMD_NO_ABSOLUTE_PATH        8  // R}h΃pXłȂ
#define EXECCMD_CMD_NOT_FOUND           9  // R}hȂ
#define EXECCMD_ERROR                   10 // \ʃG[

#define EXECCMD_CMDLINE_BUFFER_SIZE 4096
#define EXECCMD_ERROR_MSG_BUFFER_SIZE 1024


//////////////////////////////////////////////////////////////////////////////
//

class CNative2Ascii {
private:
	LPCTSTR m_pszCmdLine;
	TCHAR m_szAppPath[EXECCMD_CMDLINE_BUFFER_SIZE];
	TCHAR m_szAppParam[EXECCMD_CMDLINE_BUFFER_SIZE];
	TCHAR m_szAdditionParam[EXECCMD_CMDLINE_BUFFER_SIZE];

	BYTE* m_pInputBuffer;
	DWORD m_dwInputBufferSize;
	BYTE* m_pOutputBuffer;
	DWORD m_dwOutputBufferSize;

	DWORD m_dwErrorCode;
	DWORD m_dwSysErrorCode;
	TCHAR m_szMsg[EXECCMD_ERROR_MSG_BUFFER_SIZE];

public:
	CNative2Ascii();
	~CNative2Ascii();

private:
	BOOL ExecCommandWithStdio(LPCTSTR pszCmdLine, HANDLE hInput, HANDLE hOutput);
	BOOL ExecCommandWithMemory(LPCTSTR pszCmdLine);
	void SetErrorCode(DWORD dwErrorCode, DWORD dwSysErrorCode = 0) {
		m_dwErrorCode = dwErrorCode;
		m_dwSysErrorCode = dwSysErrorCode;
	}

public:
	BOOL Native2Ascii(LPCTSTR pszCmdLine, BYTE* pszSrc, DWORD dwSrcSize);
	BOOL Ascii2Native(LPCTSTR pszCmdLine, BYTE* pszSrc, DWORD dwSrcSize);
	BOOL SetCmdLine(LPCTSTR pszCmdLine);
	BYTE* GetOutputBuffer() {
		return m_pOutputBuffer;
	}
	DWORD GetOutputBufferSize() {
		return m_dwOutputBufferSize;
	}
	DWORD GetErrorCode() {
		return m_dwErrorCode;
	}
	DWORD GetSysErrorCode() {
		return m_dwSysErrorCode;
	}
	LPCTSTR GetErrorMsg();
};

#endif // _N2A_H_
